const Git = require('nodegit');
const packageJson = require('../package.json');

const loadAssymbly = function loadAssymbly(options, callback) {
  const summary = {
    version: packageJson.version,
  };

  let repository;

  Git.Repository.open('../')
    .then((result) => {
      repository = result;
      return repository.getHeadCommit();
    })
    .then((commit) => {
      const author = commit.author();

      summary.commit = {
        hash: commit.sha(),
        time: commit.timeMs(),
        author: author.toString(),
      };


      return repository.getCurrentBranch();
    })
    .then((branch) => {
      summary.branch = {
        name: branch.shorthand(),
        fullName: branch.name(),
      };

      callback(null, summary);
    })
    .catch((err) => {
      console.error(err);
      throw err;
    });
};

module.exports = (content) => {
  const callback = this.async();

  loadAssymbly(content, callback);
};
